Index: EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/core_kernel.trb
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/core_kernel.trb	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/core_kernel.trb	(revision 429)
@@ -6,5 +6,5 @@
 # 
 #   Copyright (C) 2015 by FUJI SOFT INCORPORATED, JAPAN
-#   Copyright (C) 2015,2016 by Embedded and Real-Time Systems Laboratory
+#   Copyright (C) 2015-2019 by Embedded and Real-Time Systems Laboratory
 #               Graduate School of Information Science, Nagoya Univ., JAPAN
 # 
@@ -38,5 +38,5 @@
 #   の責任を負わない．
 # 
-#   $Id$
+#   $Id: core_kernel.trb 662 2016-02-27 02:33:51Z ertl-hiro $
 # 
 
@@ -48,10 +48,10 @@
 #  有効なCPU例外ハンドラ番号
 #
-$EXCNO_VALID = [ 0, 1, 2, 3, 4, 5 ]
+$EXCNO_VALID = [ 0, 1, 2, 3, 4, 5, 6 ]
 
 #
 #  DEF_EXCで使用できるCPU例外ハンドラ番号
 #
-$EXCNO_DEFEXC_VALID = [ 0, 1, 2, 3, 5 ]
+$EXCNO_DEFEXC_VALID = [ 0, 1, 2, 3, 5, 6 ]
 
 #
@@ -65,5 +65,5 @@
 $kernelCfgC.comment_header("Interrupt Handler Table")
 
-$kernelCfgC.add("FP _kernel_inh_table[TNUM_INHNO] = {")
+$kernelCfgC.add("/*const*/FP _kernel_inh_table[TNUM_INHNO] = {")
 $INHNO_VALID.each_with_index do |inhnoVal, index|
   $kernelCfgC.add(",") if index > 0
Index: EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/core_kernel_impl.c
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/core_kernel_impl.c	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/core_kernel_impl.c	(revision 429)
@@ -6,5 +6,5 @@
  *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
  *                              Toyohashi Univ. of Technology, JAPAN
- *  Copyright (C) 2006-2016 by Embedded and Real-Time Systems Laboratory
+ *  Copyright (C) 2006-2019 by Embedded and Real-Time Systems Laboratory
  *              Graduate School of Information Science, Nagoya Univ., JAPAN
  * 
@@ -73,5 +73,5 @@
  */
 Inline void
-config_section_entry(ARM_MMU_CONFIG *p_ammuc)
+config_section_entry(const ARM_MMU_CONFIG *p_ammuc)
 {
 	uint32_t	vaddr = p_ammuc->vaddr;
@@ -80,4 +80,7 @@
 	uint_t		i;
 
+	assert(vaddr % ARM_SECTION_SIZE == 0);
+	assert(paddr % ARM_SECTION_SIZE == 0);
+	assert(size % ARM_SECTION_SIZE == 0);
 	while (size > 0) {
 #ifdef USE_ARM_SSECTION
@@ -170,4 +173,29 @@
 
 /*
+ *  FPUの初期化
+ */
+#ifdef USE_ARM_FPU
+
+void
+arm_fpu_initialize(void)
+{
+	uint32_t	reg;
+
+	/*
+	 *  CP10とCP11をアクセス可能に設定する．
+	 */
+	CP15_READ_CPACR(reg);
+	reg |= (CP15_CPACR_CP10_FULLACCESS | CP15_CPACR_CP11_FULLACCESS);
+	CP15_WRITE_CPACR(reg);
+
+	/*
+	 *  FPUをディスエーブルする．
+	 */
+	set_fpexc(current_fpexc() & ~FPEXC_ENABLE);
+}
+
+#endif /* USE_ARM_FPU */
+
+/*
  *  コア依存の初期化
  */
@@ -187,4 +215,11 @@
 	arm_mmu_initialize();
 #endif /* USE_ARM_MMU */
+
+	/*
+	 *  FPUの初期化
+	 */
+#ifdef USE_ARM_FPU
+	arm_fpu_initialize();
+#endif /* USE_ARM_FPU */
 
 	/*
@@ -306,8 +341,12 @@
 		syslog_0(LOG_EMERG, "FIQ exception occurs.");
 		break;
+	case EXCNO_FATAL:
+		syslog_0(LOG_EMERG, "Fatal Data Abort exception occurs.");
+		break;
 	}
 	xlog_sys(p_excinf);
 
-	if (excno == EXCNO_PABORT || excno == EXCNO_DABORT) {
+	if (excno == EXCNO_PABORT || excno == EXCNO_DABORT
+										|| excno == EXCNO_FATAL) {
 		uint32_t	fsr, far;
 
Index: EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/core_kernel_impl.h
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/core_kernel_impl.h	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/core_kernel_impl.h	(revision 429)
@@ -6,5 +6,5 @@
  *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
  *                              Toyohashi Univ. of Technology, JAPAN
- *  Copyright (C) 2006-2016 by Embedded and Real-Time Systems Laboratory
+ *  Copyright (C) 2006-2019 by Embedded and Real-Time Systems Laboratory
  *              Graduate School of Information Science, Nagoya Univ., JAPAN
  * 
@@ -55,4 +55,11 @@
 
 /*
+ *  ターゲット依存のタスク属性（エラーチェック用）
+ */
+/*#ifdef USE_ARM_FPU*/
+#define TARGET_TSKATR		(TA_FPU)
+/*#endif /* USE_ARM_FPU */
+
+/*
  *  エラーチェック方法の指定
  */
@@ -68,4 +75,7 @@
 #define CHECK_MPF_ALIGN		4		/* 固定長メモリプール領域のアライン単位 */
 #define CHECK_MPF_NONNULL			/* 固定長メモリプール領域の非NULLチェック */
+#define CHECK_MPK_ALIGN		4		/* カーネルメモリプール領域のアライン単位 */
+#define CHECK_MPK_NONNULL			/* カーネルメモリプール領域の非NULL  */
+									/*							チェック */
 #define CHECK_MB_ALIGN		4		/* 管理領域のアライン単位 */
 
@@ -269,5 +279,5 @@
  *  非タスクコンテキストからのディスパッチ要求
  */
-#define request_dispatch()
+#define request_dispatch_retint()
 
 /*
@@ -324,5 +334,5 @@
  *  割込みハンドラテーブル（kernel_cfg.c）
  */
-extern FP inh_table[TNUM_INHNO];
+extern /*const*/FP inh_table[TNUM_INHNO];
 
 /*
@@ -447,5 +457,5 @@
  *  MMUの設定情報（メモリエリアの情報）（target_kernel_impl.c）
  */
-extern ARM_MMU_CONFIG arm_memory_area[];
+extern const ARM_MMU_CONFIG arm_memory_area[];
 
 /*
@@ -458,4 +468,11 @@
 
 #ifndef TOPPERS_MACRO_ONLY
+
+/*
+ *  FPUの初期化
+ */
+#ifdef USE_ARM_FPU
+extern void arm_fpu_initialize(void);
+#endif /* USE_ARM_FPU */
 
 /*
Index: EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/core_offset.trb
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/core_offset.trb	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/core_offset.trb	(revision 429)
@@ -3,5 +3,5 @@
 #		オフセットファイル生成用Rubyテンプレート（ARM用）
 #
-#  $Id$
+#  $Id: core_offset.trb 572 2016-02-01 14:40:09Z ertl-hiro $
 #
 
@@ -14,10 +14,13 @@
 #  フィールドのオフセットの定義の生成
 #
-GenerateDefine("TCB_p_tinib", $offsetof_TCB_p_tinib)
-GenerateDefine("TCB_sp", $offsetof_TCB_sp)
-GenerateDefine("TCB_pc", $offsetof_TCB_pc)
-GenerateDefine("TINIB_exinf", $offsetof_TINIB_exinf)
-GenerateDefine("TINIB_task", $offsetof_TINIB_task)
-GenerateDefine("TINIB_stksz", $offsetof_TINIB_stksz)
-GenerateDefine("TINIB_stk", $offsetof_TINIB_stk)
-GenerateDefine("T_EXCINF_cpsr", $offsetof_T_EXCINF_cpsr)
+$offsetH.append(<<EOS)
+#define TCB_p_tinib		#{$offsetof_TCB_p_tinib}
+#define TCB_sp			#{$offsetof_TCB_sp}
+#define TCB_pc			#{$offsetof_TCB_pc}
+#define TINIB_tskatr	#{$offsetof_TINIB_tskatr}
+#define TINIB_exinf		#{$offsetof_TINIB_exinf}
+#define TINIB_task		#{$offsetof_TINIB_task}
+#define TINIB_stksz		#{$offsetof_TINIB_stksz}
+#define TINIB_stk		#{$offsetof_TINIB_stk}
+#define T_EXCINF_cpsr	#{$offsetof_T_EXCINF_cpsr}
+EOS
Index: EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/core_rename.def
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/core_rename.def	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/core_rename.def	(revision 429)
@@ -16,10 +16,9 @@
 dabort_handler
 fiq_handler
-current_cpsr
-set_cpsr
 
 # core_kernel_impl.c
 excpt_nest_count
 arm_mmu_initialize
+arm_fpu_initialize
 core_initialize
 core_terminate
@@ -28,4 +27,16 @@
 default_int_handler
 default_exc_handler
+
+# mpcore_kernel_impl.c
+mpcore_initialize
+mpcore_terminate
+
+# mpcore_timer.c
+target_hrt_initialize
+target_hrt_terminate
+target_hrt_handler
+target_ovrtimer_initialize
+target_ovrtimer_terminate
+target_ovrtimer_handler
 
 # gic_kernel_impl.c
@@ -47,6 +58,2 @@
 pl310_invalidate_all
 pl310_clean_and_invalidate_all
-
-# target_kernel_impl.c
-arm_tnum_memory_area
-arm_memory_area
Index: EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/core_rename.h
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/core_rename.h	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/core_rename.h	(revision 429)
@@ -25,6 +25,4 @@
 #define dabort_handler				_kernel_dabort_handler
 #define fiq_handler					_kernel_fiq_handler
-#define current_cpsr				_kernel_current_cpsr
-#define set_cpsr					_kernel_set_cpsr
 
 /*
@@ -33,4 +31,5 @@
 #define excpt_nest_count			_kernel_excpt_nest_count
 #define arm_mmu_initialize			_kernel_arm_mmu_initialize
+#define arm_fpu_initialize			_kernel_arm_fpu_initialize
 #define core_initialize				_kernel_core_initialize
 #define core_terminate				_kernel_core_terminate
@@ -39,4 +38,20 @@
 #define default_int_handler			_kernel_default_int_handler
 #define default_exc_handler			_kernel_default_exc_handler
+
+/*
+ *  mpcore_kernel_impl.c
+ */
+#define mpcore_initialize			_kernel_mpcore_initialize
+#define mpcore_terminate			_kernel_mpcore_terminate
+
+/*
+ *  mpcore_timer.c
+ */
+#define target_hrt_initialize		_kernel_target_hrt_initialize
+#define target_hrt_terminate		_kernel_target_hrt_terminate
+#define target_hrt_handler			_kernel_target_hrt_handler
+#define target_ovrtimer_initialize	_kernel_target_ovrtimer_initialize
+#define target_ovrtimer_terminate	_kernel_target_ovrtimer_terminate
+#define target_ovrtimer_handler		_kernel_target_ovrtimer_handler
 
 /*
@@ -65,10 +80,4 @@
 #define pl310_clean_and_invalidate_all	_kernel_pl310_clean_and_invalidate_all
 
-/*
- *  target_kernel_impl.c
- */
-#define arm_tnum_memory_area		_kernel_arm_tnum_memory_area
-#define arm_memory_area				_kernel_arm_memory_area
-
 
 #endif /* TOPPERS_CORE_RENAME_H */
Index: EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/core_sil.h
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/core_sil.h	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/core_sil.h	(revision 429)
@@ -5,5 +5,5 @@
  *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
  *                              Toyohashi Univ. of Technology, JAPAN
- *  Copyright (C) 2004-2016 by Embedded and Real-Time Systems Laboratory
+ *  Copyright (C) 2004-2018 by Embedded and Real-Time Systems Laboratory
  *              Graduate School of Information Science, Nagoya Univ., JAPAN
  * 
@@ -86,12 +86,12 @@
  *  ステータスレジスタ（CPSR）の現在値の読出し
  */
-extern uint32_t current_cpsr(void);
-#define TOPPERS_current_cpsr()	current_cpsr()
+extern uint32_t _kernel_current_cpsr(void);
+#define TOPPERS_current_cpsr()	_kernel_current_cpsr()
 
 /*
  *  ステータスレジスタ（CPSR）の現在値の変更
  */
-extern void set_cpsr(uint32_t cpsr);
-#define TOPPERS_set_cpsr(cpsr)	current_cpsr(cpsr)
+extern void _kernel_set_cpsr(uint32_t cpsr);
+#define TOPPERS_set_cpsr(cpsr)	_kernel_set_cpsr(cpsr)
 
 #endif /* __thumb__ */
@@ -138,4 +138,16 @@
 #define SIL_UNL_INT()	(TOPPERS_set_fiq_irq(TOPPERS_fiq_irq_mask))
 
+/*
+ *  メモリ同期バリア
+ */
+#ifdef DATA_SYNC_BARRIER
+#define TOPPERS_SIL_WRITE_SYNC()	DATA_SYNC_BARRIER()
+#elif __TARGET_ARCH_ARM <= 6
+#define TOPPERS_SIL_WRITE_SYNC() \
+						Asm("mcr p15, 0, %0, c7, c10, 4"::"r"(0):"memory")
+#else /* __TARGET_ARCH_ARM <= 6 */
+#define TOPPERS_SIL_WRITE_SYNC()	Asm("dsb":::"memory")
+#endif
+
 #endif /* TOPPERS_MACRO_ONLY */
 #endif /* TOPPERS_CORE_SIL_H */
Index: EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/core_support.S
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/core_support.S	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/core_support.S	(revision 429)
@@ -6,5 +6,5 @@
  *  Copyright (C) 2000-2004 by Embedded and Real-Time Systems Laboratory
  *                              Toyohashi Univ. of Technology, JAPAN
- *  Copyright (C) 2006-2017 by Embedded and Real-Time Systems Laboratory
+ *  Copyright (C) 2006-2019 by Embedded and Real-Time Systems Laboratory
  *              Graduate School of Information Science, Nagoya Univ., JAPAN
  * 
@@ -55,4 +55,11 @@
 
 /*
+ *  使用する命令セットの定義
+ */
+#ifdef USE_ARM_FPU
+	.fpu	vfpv3
+#endif /* USE_ARM_FPU */
+
+/*
  *  例外ベクタ
  */
@@ -101,11 +108,20 @@
 	 *  マスク全解除状態・ディスパッチ許可状態で呼び出される．
 	 */
-	push	{r12,lr}				/* 戻り番地を保存，r12はダミー */
+	push	{r12,lr}				/* 戻り番地（lr）を保存 */
+									/* r12はアラインメントのため */
 #ifdef TOPPERS_SUPPORT_OVRHDR
 	bl		ovrtimer_stop
 #endif /* TOPPERS_SUPPORT_OVRHDR */
-	stmfd	sp!, {r4-r11}			/* 非スクラッチレジスタの保存 */
+	push	{r4-r11}				/* 非スクラッチレジスタの保存 */
 	ldr		r0, =p_runtsk			/* p_runtsk → r0 */
 	ldr		r0, [r0]
+#ifdef USE_ARM_FPU
+	ldr		r2, [r0,#TCB_p_tinib]	/* p_runtsk->p_tinib → r2 */
+	ldr		r1, [r2,#TINIB_tskatr]	/* p_runtsk->p_tinib->tskatr → r1 */
+	tst		r1, #TA_FPU
+	beq		1f
+	vpush	{d8-d15}				/* 非スクラッチFPUレジスタの保存 */
+1:
+#endif /* USE_ARM_FPU */
 	str		sp, [r0,#TCB_sp]		/* スタックポインタを保存 */
 	adr		r1, dispatch_r
@@ -114,5 +130,21 @@
 
 ALABEL(dispatch_r)
-	ldmfd	sp!, {r4-r11}			/* 非スクラッチレジスタの復帰 */
+	/*
+	 * 【この時点のレジスタ状態】
+	 *  r4：p_runtsk（タスク切換え後）
+	 */
+#ifdef USE_ARM_FPU
+	ldr		r2, [r4,#TCB_p_tinib]	/* p_runtsk->p_tinib → r2 */
+	ldr		r1, [r2,#TINIB_tskatr]	/* p_runtsk->p_tinib->tskatr → r1 */
+	tst		r1, #TA_FPU
+	vmrs	r0, fpexc
+	biceq	r0, r0, #FPEXC_ENABLE
+	orrne	r0, r0, #FPEXC_ENABLE
+	vmsr	fpexc, r0				/* FPEXCを設定 */
+	beq		1f
+	vpop	{d8-d15}				/* 非スクラッチFPUレジスタの復帰 */
+1:
+#endif /* USE_ARM_FPU */
+	pop		{r4-r11}				/* 非スクラッチレジスタの復帰 */
 #ifdef TOPPERS_SUPPORT_OVRHDR
 	bl		ovrtimer_start
@@ -137,4 +169,9 @@
 
 	/*
+	 *  各種のデバイス（特に割込みコントローラ）の設定が完了するのを待つ．
+	 */
+	asm_data_sync_barrier r0
+	
+	/*
 	 *	タスクコンテキストに切り換える．
 	 */
@@ -184,5 +221,5 @@
 	bl		log_dsp_enter
 #endif /* LOG_DSP_ENTER */
-	
+
 ALABEL(dispatcher_0)
 	/*
@@ -232,6 +269,9 @@
 ALABEL(call_exit_kernel)
 	msr		cpsr_c, #(CPSR_SVC_MODE AOR CPSR_INTLOCK)
-	ldr		r0, =istkpt				/* 非タスクコンテキストのスタックへ */
+	ldr		r0, =istkpt				/* 非タスクコンテキスト用のスタックに */
 	ldr		sp, [r0]
+	ldr		r0, =excpt_nest_count	/* 例外ネストカウントを1に */
+	mov		r1, #1
+	str		r1, [r0]
 	b		exit_kernel
 
@@ -243,5 +283,6 @@
 	AGLOBAL(start_r)
 	/*
-	 *  ディスパッチャ本体から呼び出されるため，p_runtskはr4に入っている．
+	 * 【この時点のレジスタ状態】
+	 *  r4：p_runtsk（タスク切換え後）
 	 */
 ALABEL(start_r)
@@ -253,4 +294,12 @@
 	ldr		lr, =ext_tsk			/* タスク本体からの戻り番地を設定 */
 	ldr		r2, [r4,#TCB_p_tinib]	/* p_runtsk->p_tinib → r2 */
+#ifdef USE_ARM_FPU
+	ldr		r1, [r2,#TINIB_tskatr]	/* p_runtsk->p_tinib->tskatr → r1 */
+	tst		r1, #TA_FPU
+	vmrs	r0, fpexc
+	biceq	r0, r0, #FPEXC_ENABLE
+	orrne	r0, r0, #FPEXC_ENABLE
+	vmsr	fpexc, r0				/* FPEXCを設定 */
+#endif /* USE_ARM_FPU */
 	ldr		r0, [r2,#TINIB_exinf]	/* exinfをパラメータに */
 	ldr		r1, [r2,#TINIB_task]	/* タスク起動番地にジャンプ */
@@ -270,11 +319,12 @@
 #if __TARGET_ARCH_ARM < 6
 	/*
-	 *  スーパバイザモードに切り換え，スクラッチレジスタを保存する．
+	 *  スーパバイザモードに切り換え，スクラッチレジスタ＋αを保存する．
 	 */
 	msr		cpsr_c, #(CPSR_SVC_MODE AOR CPSR_IRQ_BIT)
-	stmfd	sp!, {r0-r5,r12,lr,pc}		/* pcはスペース確保のため */
-
-	/*
-	 *  IRQモードに戻して，戻り番地とspsr（戻り先のcpsr）を取得する．
+	push	{r0-r5,r12,lr,pc}		/* pcはスペース確保のため */
+
+	/*
+	 *  IRQモードに戻して，戻り番地（lr-4）と戻り先のcpsr（spsr）を取
+	 *  得する．
 	 */
 	msr		cpsr_c, #(CPSR_IRQ_MODE AOR CPSR_IRQ_BIT)
@@ -283,13 +333,13 @@
 
 	/*
-	 *  スーパバイザモードに切り換え，戻り番地とspsrを保存する．
+	 *  スーパバイザモードに切り換え，戻り番地と戻り先のcpsrを保存する．
 	 */
 	msr		cpsr_c, #(CPSR_SVC_MODE AOR CPSR_IRQ_BIT)
-	str		r2, [sp,#0x20]			/* 戻り番地をスタックに保存 */
-	push	{r1}					/* spsrをスタックに保存 */
+	str		r2, [sp,#0x20]			/* 戻り番地をスタックに保存（pcの場所）*/
+	push	{r1}					/* 戻り先のcpsrをスタックに保存 */
 #else /* __TARGET_ARCH_ARM < 6 */
 	/*
-	 *  戻り先（lr）とspsr（cpsr_svc）をスーパバイザモードのスタックに
-	 *  保存する．
+	 *  戻り番地（lr）と戻り先のcpsr（spsr）をスーパバイザモードのスタッ
+	 *  クに保存する．
 	 */
 	sub		lr, lr, #4				/* 戻り番地の算出 */
@@ -297,8 +347,8 @@
 
 	/*
-	 *  スーパバイザモードに切り換え，スクラッチレジスタを保存する．
+	 *  スーパバイザモードに切り換え，スクラッチレジスタ＋αを保存する．
 	 */
 	cps		#CPSR_SVC_MODE
-	stmfd	sp!, {r0-r5,r12,lr}
+	push	{r0-r5,r12,lr}
 #endif /* __TARGET_ARCH_ARM < 6 */
 
@@ -308,6 +358,6 @@
 	and		r1, sp, #4
 	sub		sp, sp, r1
-	push	{r0,r1}					/* r0はスペース確保のため */
-
+	push	{r0,r1}					/* スタックポインタの調整値を保存 */
+									/* r0はスペース確保のため */
 	/*
 	 *  例外ネストカウントをインクリメントする．割込みが非タスクコンテキ
@@ -328,4 +378,14 @@
 #endif /* TOPPERS_SUPPORT_OVRHDR */
 
+#ifdef USE_ARM_FPU
+	/*
+	 *  FPUをディスエーブルする．
+	 */
+	vmrs	r0, fpexc
+	str		r0, [sp]				/* FPEXCを保存（r0の場所）*/
+	bic		r0, r0, #FPEXC_ENABLE
+	vmsr	fpexc, r0				/* FPEXCを設定 */
+#endif /* USE_ARM_FPU */
+	
 	/*
 	 *  非タスクコンテキスト用のスタックに切り換える．
@@ -339,4 +399,7 @@
 	/*
 	 *  割込みコントローラを操作し，割込み番号を取得する．
+	 *
+	 *  irc_begin_intは，スタックトップ（r0の場所）に，irc_end_intで用
+	 *  いる情報を保存する．
 	 */
 	bl		irc_begin_int
@@ -345,5 +408,5 @@
 #else /* TNUM_INHNO <= 256 || __TARGET_ARCH_ARM <= 6 */
 	movw	r3, #TNUM_INHNO
-	cmp		r4, r3			
+	cmp		r4, r3
 #endif /* TNUM_INHNO <= 256 || __TARGET_ARCH_ARM <= 6 */
 	bhs		irq_handler_2			/* スプリアス割込みなら */
@@ -420,4 +483,12 @@
 	mov   	sp, r3
 
+#ifdef USE_ARM_FPU
+	/*
+	 *  FPUを元に戻す．
+	 */
+	ldr		r0, [sp]				/* FPEXCを復帰 */
+	vmsr	fpexc, r0
+#endif /* USE_ARM_FPU */
+	
 	/*
 	 *  p_runtskがNULLか判定する．
@@ -433,5 +504,5 @@
 	pop		{r0,r1}					/* スタックポインタの調整を元に戻す */
 	add		sp, sp, r1
-	add		sp, sp, #40				/* スクラッチレジスタを捨てる */
+	add		sp, sp, #40				/* スクラッチレジスタ等を捨てる */
 	b		dispatcher_0
 
@@ -440,4 +511,8 @@
 	 */
 ALABEL(irq_handler_3)
+	/*
+	 * 【この時点のレジスタ状態】
+	 *  r0：p_runtsk
+	 */
 	ldr		r1, =p_schedtsk			/* p_schedtsk → r1 */
 	ldr		r1, [r1]
@@ -448,5 +523,18 @@
 	 *  コンテキストを保存する．
 	 */
-	stmfd	sp!, {r6-r11}			/* 非スクラッチレジスタの保存 */
+	push	{r6-r11}				/* 残りのレジスタの保存 */
+#ifdef USE_ARM_FPU
+	ldr		r2, [r0,#TCB_p_tinib]	/* p_runtsk->p_tinib → r2 */
+	ldr		r1, [r2,#TINIB_tskatr]	/* p_runtsk->p_tinib->tskatr → r1 */
+	tst		r1, #TA_FPU
+	beq		1f						/* TA_FPU属性でない場合は分岐 */
+#ifdef USE_ARM_FPU_D32
+	vpush	{d16-d31}
+#endif /* USE_ARM_FPU_D32 */
+	vpush	{d0-d15}				/* 全FPUレジスタの保存 */
+	vmrs	r1, fpscr
+	push	{r1,r2}					/* FPSCRの保存 */
+1:									/* r2はアラインメントのため */
+#endif /* USE_ARM_FPU */
 	str		sp, [r0,#TCB_sp]		/* スタックポインタを保存 */
 	adr		r1, ret_int_r			/* 実行再開番地を保存 */
@@ -457,6 +545,26 @@
 	/*
 	 *  コンテキストを復帰する．
-	 */
-	ldmfd	sp!, {r6-r11}			/* 非スクラッチレジスタの復帰 */
+	 *
+	 * 【この時点のレジスタ状態】
+	 *  r4：p_runtsk（タスク切換え後）
+	 */
+#ifdef USE_ARM_FPU
+	ldr		r2, [r4,#TCB_p_tinib]	/* p_runtsk->p_tinib → r2 */
+	ldr		r1, [r2,#TINIB_tskatr]	/* p_runtsk->p_tinib->tskatr → r1 */
+	tst		r1, #TA_FPU
+	vmrs	r0, fpexc
+	biceq	r0, r0, #FPEXC_ENABLE
+	orrne	r0, r0, #FPEXC_ENABLE
+	vmsr	fpexc, r0				/* FPEXCを設定 */
+	beq		1f						/* TA_FPU属性でない場合は分岐 */
+	pop		{r1,r2}					/* FPSCRの復帰 */
+	vmsr	fpscr, r1
+	vpop	{d0-d15}				/* 全FPUレジスタの復帰 */
+#ifdef USE_ARM_FPU_D32
+	vpop	{d16-d31}
+#endif /* USE_ARM_FPU_D32 */
+1:
+#endif /* USE_ARM_FPU */
+	pop		{r6-r11}				/* 残りのレジスタの復帰 */
 
 ALABEL(irq_handler_4)
@@ -469,9 +577,9 @@
 
 	/*
-	 *  割込み／CPU例外処理からのリターン
+	 *  割込み処理からのリターン
 	 *
-	 *  割込み／CPU例外処理からのリターンにより，CPUロック解除状態に遷
-	 *  移するようにする必要があるが，ARMはCPSRのビットによってCPUロッ
-	 *  ク状態を表しているため，CPSRを元に戻してリターンすればよい．
+	 *  割込み処理からのリターンにより，CPUロック解除状態に遷移するよ
+	 *  うにする必要があるが，ARMはCPSRのビットによってCPUロック状態を
+	 *  表しているため，CPSRを元に戻してリターンすればよい．
 	 */
 ALABEL(irq_handler_5)
@@ -480,10 +588,10 @@
 
 #if __TARGET_ARCH_ARM < 6
-	ldmfd	sp!, {r0}				/* 戻り先のcpsrをspsrに設定 */
+	pop		{r0}					/* 戻り先のcpsrをspsrに設定 */
 	msr		spsr_cxsf, r0
 	ldmfd	sp!, {r0-r5,r12,lr,pc}^	/* コンテキストの復帰 */
 									/* ^付きなので，spsr → cpsr */
 #else /* __TARGET_ARCH_ARM < 6 */
-	ldmfd	sp!, {r0-r5,r12,lr}
+	pop		{r0-r5,r12,lr}			/* スクラッチレジスタ＋αの復帰 */
 	rfefd	sp!
 #endif /* __TARGET_ARCH_ARM < 6 */
@@ -509,11 +617,12 @@
 	/*
 	 *  IビットとFビットをセットし，スーパバイザモードに切り換え，スク
-	 *  ラッチレジスタを保存する．
+	 *  ラッチレジスタ＋αを保存する．
 	 */
 	msr		cpsr_c, #(CPSR_SVC_MODE AOR CPSR_FIQ_IRQ_BIT)
-	stmfd	sp!, {r0-r5,r12,lr,pc}		/* pcはスペース確保のため */
-
-	/*
-	 *  未定義モードに戻して，戻り番地とspsrを取得する．
+	push	{r0-r5,r12,lr,pc}		/* pcはスペース確保のため */
+
+	/*
+	 *  未定義モードに戻して，戻り番地（lr）と戻り先のcpsr（spsr）を取
+	 *  得する．
 	 */
 	msr		cpsr_c, #(CPSR_UND_MODE AOR CPSR_FIQ_IRQ_BIT)
@@ -522,21 +631,21 @@
 
 	/*
-	 *  スーパバイザモードに切り換え，戻り番地とspsrを保存する．
+	 *  スーパバイザモードに切り換え，戻り番地と戻り先のcpsrを保存する．
 	 */
 	msr		cpsr_c, #(CPSR_SVC_MODE AOR CPSR_FIQ_IRQ_BIT)
-	str		r2, [sp,#0x20]			/* 戻り番地をスタックに保存 */
-	push	{r1}					/* spsrをスタックに保存 */
+	str		r2, [sp,#0x20]			/* 戻り番地をスタックに保存（pcの場所）*/
+	push	{r1}					/* 戻り先のcpsrをスタックに保存 */
 #else /* __TARGET_ARCH_ARM < 6 */
 	/*
-	 *  戻り先（lr）とspsr（cpsr_svc）をスーパバイザモードのスタックに
-	 *  保存する．
+	 *  戻り番地（lr）と戻り先のcpsr（spsr）をスーパバイザモードのスタッ
+	 *  クに保存する．
 	 */
 	srsfd	#CPSR_SVC_MODE!
 
 	/*
-	 *  スーパバイザモードに切り換え，スクラッチレジスタを保存する．
+	 *  スーパバイザモードに切り換え，スクラッチレジスタ＋αを保存する．
 	 */
 	cps		#CPSR_SVC_MODE
-	stmfd	sp!, {r0-r5,r12,lr}
+	push	{r0-r5,r12,lr}
 #endif /* __TARGET_ARCH_ARM < 6 */
 	mov		r4, #EXCNO_UNDEF
@@ -558,32 +667,23 @@
 #if __TARGET_ARCH_ARM < 6
 	/*
-	 *  IビットとFビットをセットし，スクラッチレジスタを保存する．
+	 *  IビットとFビットをセットし，戻り番地（lr），スクラッチレジスタ
+	 *  ＋α，戻り先のcpsr（spsr）を保存する（lrは二重に保存される）．
 	 */
 	msr		cpsr_c, #(CPSR_SVC_MODE AOR CPSR_FIQ_IRQ_BIT)
-	stmfd	sp!, {r0-r5,r12,lr,pc}		/* pcはスペース確保のため */
-
-	/*
-	 *  戻り番地とspsrを取得する．
-	 */
-	mov		r2, lr
+	push	{lr}
+	push	{r0-r5,r12,lr}
 	mrs		r1, spsr
-
-	/*
-	 *  戻り番地とspsrを保存する．
-	 */
-	str		r2, [sp,#0x20]			/* 戻り番地をスタックに保存 */
-	push	{r1}					/* spsrをスタックに保存 */
+	push	{r1}
 #else /* __TARGET_ARCH_ARM < 6 */
 	/*
-	 *  戻り先（lr）とspsr（cpsr_svc）をスーパバイザモードのスタックに
-	 *  保存する．
+	 *  戻り番地（lr）と戻り先のcpsr（spsr）をスーパバイザモードのスタッ
+	 *  クに保存する．
 	 */
 	srsfd	#CPSR_SVC_MODE!
 
 	/*
-	 *  スーパバイザモードで，スクラッチレジスタを保存する．
-	 */
-	cps		#CPSR_SVC_MODE			/* 不要と思われる */
-	stmfd	sp!, {r0-r5,r12,lr}
+	 *  スーパバイザモードで，スクラッチレジスタ＋αを保存する．
+	 */
+	push	{r0-r5,r12,lr}
 #endif /* __TARGET_ARCH_ARM < 6 */
 	mov		r4, #EXCNO_SVC
@@ -605,11 +705,12 @@
 	/*
 	 *  IビットとFビットをセットし，スーパバイザモードに切り換え，スク
-	 *  ラッチレジスタを保存する．
+	 *  ラッチレジスタ＋αを保存する．
 	 */
 	msr		cpsr_c, #(CPSR_SVC_MODE AOR CPSR_FIQ_IRQ_BIT)
-	stmfd	sp!, {r0-r5,r12,lr,pc}		/* pcはスペース確保のため */
-
-	/*
-	 *  アボートモードに戻して，戻り番地とspsrを取得する．
+	push	{r0-r5,r12,lr,pc}		/* pcはスペース確保のため */
+
+	/*
+	 *  アボートモードに戻して，戻り番地（lr）と戻り先のcpsr（spsr）を
+	 *  取得する．
 	 */
 	msr		cpsr_c, #(CPSR_ABT_MODE AOR CPSR_FIQ_IRQ_BIT)
@@ -618,21 +719,21 @@
 
 	/*
-	 *  スーパバイザモードに切り換え，戻り番地とspsrを保存する．
+	 *  スーパバイザモードに切り換え，戻り番地と戻り先のcpsrを保存する．
 	 */
 	msr		cpsr_c, #(CPSR_SVC_MODE AOR CPSR_FIQ_IRQ_BIT)
-	str		r2, [sp,#0x20]			/* 戻り番地をスタックに保存 */
-	push	{r1}					/* spsrをスタックに保存 */
+	str		r2, [sp,#0x20]			/* 戻り番地をスタックに保存（pcの場所）*/
+	push	{r1}					/* 戻り先のcpsrをスタックに保存 */
 #else /* __TARGET_ARCH_ARM < 6 */
 	/*
-	 *  戻り先（lr）とspsr（cpsr_svc）をスーパバイザモードのスタックに
-	 *  保存する．
+	 *  戻り番地（lr）と戻り先のcpsr（spsr）をスーパバイザモードのスタッ
+	 *  クに保存する．
 	 */
 	srsfd	#CPSR_SVC_MODE!
 
 	/*
-	 *  スーパバイザモードに切り換え，スクラッチレジスタを保存する．
+	 *  スーパバイザモードに切り換え，スクラッチレジスタ＋αを保存する．
 	 */
 	cps		#CPSR_SVC_MODE
-	stmfd	sp!, {r0-r5,r12,lr}
+	push	{r0-r5,r12,lr}
 #endif /* __TARGET_ARCH_ARM < 6 */
 	mov		r4, #EXCNO_PABORT
@@ -653,11 +754,11 @@
 	 *  データアボートが，CPU例外の入口（start_exc_entryとend_exc_entry
 	 *  の間）で発生した場合には，fatal_dabort_handlerに分岐する．アボー
-	 *  トモードのspを汎用レジスタの代わりに使用する．
-	 */
-	ldr		sp, =start_exc_entry+8
-	cmp		lr, sp
+	 *  トモードのspを汎用レジスタの代わりに使用する（r13と記述している）．
+	 */
+	adr		r13, start_exc_entry+8
+	cmp		lr, r13
 	bcc		dabort_handler_1
-	ldr		sp, =end_exc_entry+8
-	cmp		lr, sp
+	adr		r13, end_exc_entry+8
+	cmp		lr, r13
 	bcc		fatal_dabort_handler
 
@@ -666,11 +767,12 @@
 	/*
 	 *  IビットとFビットをセットし，スーパバイザモードに切り換え，スク
-	 *  ラッチレジスタを保存する．
+	 *  ラッチレジスタ＋αを保存する．
 	 */
 	msr		cpsr_c, #(CPSR_SVC_MODE AOR CPSR_FIQ_IRQ_BIT)
-	stmfd	sp!, {r0-r5,r12,lr,pc}		/* pcはスペース確保のため */
-
-	/*
-	 *  アボートモードに戻して，戻り番地とspsrを取得する．
+	push	{r0-r5,r12,lr,pc}		/* pcはスペース確保のため */
+
+	/*
+	 *  アボートモードに戻して，戻り番地（lr）と戻り先のcpsr（spsr）を
+	 *  取得する．
 	 */
 	msr		cpsr_c, #(CPSR_ABT_MODE AOR CPSR_FIQ_IRQ_BIT)
@@ -679,25 +781,24 @@
 
 	/*
-	 *  スーパバイザモードに切り換え，戻り番地とspsrを保存する．
+	 *  スーパバイザモードに切り換え，戻り番地と戻り先のcpsrを保存する．
 	 */
 	msr		cpsr_c, #(CPSR_SVC_MODE AOR CPSR_FIQ_IRQ_BIT)
-	str		r2, [sp,#0x20]			/* 戻り番地をスタックに保存 */
-	push	{r1}					/* spsrをスタックに保存 */
+	str		r2, [sp,#0x20]			/* 戻り番地をスタックに保存（pcの場所）*/
+	push	{r1}					/* 戻り先のcpsrをスタックに保存 */
 #else /* __TARGET_ARCH_ARM < 6 */
 	/*
-	 *  戻り先（lr）とspsr（cpsr_svc）をスーパバイザモードのスタックに
-	 *  保存する．
+	 *  戻り番地（lr）と戻り先のcpsr（spsr）をスーパバイザモードのスタッ
+	 *  クに保存する．
 	 */
 	srsfd	#CPSR_SVC_MODE!
 
 	/*
-	 *  スーパバイザモードに切り換え，スクラッチレジスタを保存する．
+	 *  スーパバイザモードに切り換え，スクラッチレジスタ＋αを保存する．
 	 */
 	cps		#CPSR_SVC_MODE
-	stmfd	sp!, {r0-r5,r12,lr}
+	push	{r0-r5,r12,lr}
 #endif /* __TARGET_ARCH_ARM < 6 */
 	mov		r4, #EXCNO_DABORT
 	b		exc_handler_1
-#endif /* OMIT_DABORT_HANDLER */
 
 /*
@@ -708,13 +809,14 @@
 	/*
 	 *  IビットとFビットをセットし，スーパバイザモードに切り換え，スタッ
-	 *  クポインタを初期化し，スクラッチレジスタを保存する．
+	 *  クポインタを初期化し，スクラッチレジスタ＋αを保存する．
 	 */
 	msr		cpsr_c, #(CPSR_SVC_MODE AOR CPSR_FIQ_IRQ_BIT)
 	ldr		sp, =istkpt
 	ldr		sp, [sp]
-	stmfd	sp!, {r0-r5,r12,lr,pc}		/* pcはスペース確保のため */
-
-	/*
-	 *  アボートモードに戻して，戻り番地とspsrを取得する．
+	push	{r0-r5,r12,lr,pc}		/* pcはスペース確保のため */
+
+	/*
+	 *  アボートモードに戻して，戻り番地（lr）と戻り先のcpsr（spsr）を
+	 *  取得する．
 	 */
 	msr		cpsr_c, #(CPSR_ABT_MODE AOR CPSR_FIQ_IRQ_BIT)
@@ -723,9 +825,9 @@
 
 	/*
-	 *  スーパバイザモードに切り換え，戻り番地とspsrを保存する．
+	 *  スーパバイザモードに切り換え，戻り番地と戻り先のcpsrを保存する．
 	 */
 	msr		cpsr_c, #(CPSR_SVC_MODE AOR CPSR_FIQ_IRQ_BIT)
-	str		r2, [sp,#0x20]			/* 戻り番地をスタックに保存 */
-	push	{r1}					/* spsrをスタックに保存 */
+	str		r2, [sp,#0x20]			/* 戻り番地をスタックに保存（pcの場所）*/
+	push	{r1}					/* 戻り先のcpsrをスタックに保存 */
 #else /* __TARGET_ARCH_ARM < 6 */
 	/*
@@ -738,6 +840,6 @@
 
 	/*
-	 *  アボートモードに戻して，戻り先（lr）とspsr（cpsr_svc）をスーパ
-	 *  バイザモードのスタックに保存する．
+	 *  アボートモードに戻して，戻り番地（lr）と戻り先のcpsr（spsr）を
+	 *  スーパバイザモードのスタックに保存する．
 	 */
 	cps		#CPSR_ABT_MODE
@@ -745,20 +847,21 @@
 
 	/*
-	 *  スーパバイザモードに切り換え，スクラッチレジスタを保存する．
+	 *  スーパバイザモードに切り換え，スクラッチレジスタ＋αを保存する．
 	 */
 	cps		#CPSR_SVC_MODE
-	stmfd	sp!, {r0-r5,r12,lr}
+	push	{r0-r5,r12,lr}
 #endif /* __TARGET_ARCH_ARM < 6 */
 
 	/*
-	 *  例外ネストカウントの最上位ビットを1にする．
+	 *  例外ネストカウントをインクリメントする．
 	 */
 	ldr		r2, =excpt_nest_count
 	ldr		r3, [r2]
-	orr		r3, r3, #0x80000000
+	add		r3, r3, #1
 	str		r3, [r2]
 
-	mov		r4, #EXCNO_DABORT
+	mov		r4, #EXCNO_FATAL
 	b		exc_handler_1
+#endif /* OMIT_DABORT_HANDLER */
 
 /*
@@ -776,11 +879,12 @@
 	/*
 	 *  IビットとFビットをセットし，スーパバイザモードに切り換え，スク
-	 *  ラッチレジスタを保存する．
+	 *  ラッチレジスタ＋αを保存する．
 	 */
 	msr		cpsr_c, #(CPSR_SVC_MODE AOR CPSR_FIQ_IRQ_BIT)
-	stmfd	sp!, {r0-r5,r12,lr,pc}		/* pcはスペース確保のため */
-
-	/*
-	 *  FIQモードに戻して，戻り番地とspsrを取得する．
+	push	{r0-r5,r12,lr,pc}		/* pcはスペース確保のため */
+
+	/*
+	 *  FIQモードに戻して，戻り番地（lr）と戻り先のcpsr（spsr）を取得
+	 *  する．
 	 */
 	msr		cpsr_c, #(CPSR_FIQ_MODE AOR CPSR_FIQ_IRQ_BIT)
@@ -789,36 +893,36 @@
 
 	/*
-	 *  スーパバイザモードに切り換え，戻り番地とspsrを保存する．
+	 *  スーパバイザモードに切り換え，戻り番地と戻り先のcpsrを保存する．
 	 */
 	msr		cpsr_c, #(CPSR_SVC_MODE AOR CPSR_FIQ_IRQ_BIT)
-	str		r2, [sp,#0x20]			/* 戻り番地をスタックに保存 */
-	push	{r1}					/* spsrをスタックに保存 */
+	str		r2, [sp,#0x20]			/* 戻り番地をスタックに保存（pcの場所）*/
+	push	{r1}					/* 戻り先のcpsrをスタックに保存 */
 #else /* __TARGET_ARCH_ARM < 6 */
 	/*
-	 *  戻り先（lr）とspsr（cpsr_svc）をスーパバイザモードのスタックに
-	 *  保存する．
+	 *  戻り番地（lr）と戻り先のcpsr（spsr）をスーパバイザモードのスタッ
+	 *  クに保存する．
 	 */
 	srsfd	#CPSR_SVC_MODE!
 
 	/*
-	 *  スーパバイザモードに切り換え，スクラッチレジスタを保存する．
+	 *  スーパバイザモードに切り換え，スクラッチレジスタ＋αを保存する．
 	 */
 	cps		#CPSR_SVC_MODE
-	stmfd	sp!, {r0-r5,r12,lr}
+	push	{r0-r5,r12,lr}
 #endif /* __TARGET_ARCH_ARM < 6 */
 	mov		r4, #EXCNO_FIQ
 	b		exc_handler_1
 #endif /* OMIT_FIQ_HANDLER */
-	
+
 ALABEL(end_exc_entry)
 
 /*
  *  CPU例外ハンドラ出入口処理の共通部分
- *
- * 【この時点のレジスタ状態】
- *  r4：CPU例外ハンドラ番号
  */
 ALABEL(exc_handler_1)
 	/*
+	 * 【この時点のレジスタ状態】
+	 *  r4：CPU例外ハンドラ番号
+	 *
 	 *  CPU例外が発生した状況の判断に用いるために，CPU例外発生前の割
 	 *  込み優先度マスクと例外ネストカウントをスタックに保存する．
@@ -836,6 +940,6 @@
 	and		r1, sp, #4
 	sub		sp, sp, r1
-	push	{r0,r1}					/* r0はスペース確保のため */
-
+	push	{r0,r1}					/* スタックポインタの調整値を保存 */
+									/* r0はスペース確保のため */
 	/*
 	 *  カーネル管理外のCPU例外か判定する
@@ -873,4 +977,14 @@
 #endif /* TOPPERS_SUPPORT_OVRHDR */
 
+#ifdef USE_ARM_FPU
+	/*
+	 *  FPUをディスエーブルする．
+	 */
+	vmrs	r0, fpexc
+	str		r0, [sp]				/* FPEXCを保存（r0の場所）*/
+	bic		r0, r0, #FPEXC_ENABLE
+	vmsr	fpexc, r0				/* FPEXCを設定 */
+#endif /* USE_ARM_FPU */
+	
 	/*
 	 *  非タスクコンテキスト用のスタックに切り換える．
@@ -890,4 +1004,7 @@
 	/*
 	 *  （必要なら）割込みコントローラを操作する．
+	 *
+	 *  irc_begin_excは，スタックトップ（r0の場所）に，irc_end_excで用
+	 *  いる情報を保存する．
 	 */
 	bl		irc_begin_exc
@@ -970,4 +1087,12 @@
 	mov		sp, r3
 
+#ifdef USE_ARM_FPU
+	/*
+	 *  FPUを元に戻す．
+	 */
+	ldr		r0, [sp]				/* FPEXCを復帰 */
+	vmsr	fpexc, r0
+#endif /* USE_ARM_FPU */
+	
 	/*
 	 *  p_runtskがNULLか判定する．
@@ -990,4 +1115,8 @@
 	 */
 ALABEL(exc_handler_3)
+	/*
+	 * 【この時点のレジスタ状態】
+	 *  r0：p_runtsk
+	 */
 	ldr		r1, =p_schedtsk			/* p_schedtsk → r1 */
 	ldr		r1, [r1]
@@ -998,5 +1127,18 @@
 	 *  コンテキストを保存する．
 	 */
-	stmfd	sp!, {r6-r11}			/* 非スクラッチレジスタの保存 */
+	push	{r6-r11}				/* 残りのレジスタの保存 */
+#ifdef USE_ARM_FPU
+	ldr		r2, [r0,#TCB_p_tinib]	/* p_runtsk->p_tinib → r2 */
+	ldr		r1, [r2,#TINIB_tskatr]	/* p_runtsk->p_tinib->tskatr → r1 */
+	tst		r1, #TA_FPU
+	beq		1f						/* TA_FPU属性でない場合は分岐 */
+#ifdef USE_ARM_FPU_D32
+	vpush	{d16-d31}
+#endif /* USE_ARM_FPU_D32 */
+	vpush	{d0-d15}				/* 全FPUレジスタの保存 */
+	vmrs	r1, fpscr
+	push	{r1,r2}					/* FPSCRの保存 */
+1:									/* r2はアラインメントのため */
+#endif /* USE_ARM_FPU */
 	str		sp, [r0,#TCB_sp]		/* スタックポインタを保存 */
 	adr		r1, ret_exc_r			/* 実行再開番地を保存 */
@@ -1007,6 +1149,26 @@
 	/*
 	 *  コンテキストを復帰する．
-	 */
-	ldmfd	sp!, {r6-r11}			/* 非スクラッチレジスタの復帰 */
+	 *
+	 * 【この時点のレジスタ状態】
+	 *  r4：p_runtsk（タスク切換え後）
+	 */
+#ifdef USE_ARM_FPU
+	ldr		r2, [r4,#TCB_p_tinib]	/* p_runtsk->p_tinib → r2 */
+	ldr		r1, [r2,#TINIB_tskatr]	/* p_runtsk->p_tinib->tskatr → r1 */
+	tst		r1, #TA_FPU
+	vmrs	r0, fpexc
+	biceq	r0, r0, #FPEXC_ENABLE
+	orrne	r0, r0, #FPEXC_ENABLE
+	vmsr	fpexc, r0				/* FPEXCを設定 */
+	beq		1f						/* TA_FPU属性でない場合は分岐 */
+	pop		{r1,r2}					/* FPSCRの復帰 */
+	vmsr	fpscr, r1
+	vpop	{d0-d15}				/* 全FPUレジスタの復帰 */
+#ifdef USE_ARM_FPU_D32
+	vpop	{d16-d31}
+#endif /* USE_ARM_FPU_D32 */
+1:
+#endif /* USE_ARM_FPU */
+	pop		{r6-r11}				/* 残りのレジスタの復帰 */
 
 ALABEL(exc_handler_4)
@@ -1031,10 +1193,10 @@
 
 #if __TARGET_ARCH_ARM < 6
-	ldmfd	sp!, {r0}				/* 戻り先のcpsrをspsrに設定 */
+	pop		{r0}					/* 戻り先のcpsrをspsrに設定 */
 	msr		spsr_cxsf, r0
 	ldmfd	sp!, {r0-r5,r12,lr,pc}^	/* コンテキストの復帰 */
 									/* ^付きなので，spsr → cpsr */
 #else /* __TARGET_ARCH_ARM < 6 */
-	ldmfd	sp!, {r0-r5,r12,lr}
+	pop		{r0-r5,r12,lr}			/* スクラッチレジスタ＋αの復帰 */
 	rfefd	sp!
 #endif /* __TARGET_ARCH_ARM < 6 */
@@ -1061,4 +1223,14 @@
 	bne		nk_exc_handler_2		/*		 	ならnk_exc_handler_2に分岐 */
 
+#ifdef USE_ARM_FPU
+	/*
+	 *  FPUをディスエーブルする．
+	 */
+	vmrs	r0, fpexc
+	str		r0, [sp]				/* FPEXCを保存（r0の場所）*/
+	bic		r0, r0, #FPEXC_ENABLE
+	vmsr	fpexc, r0				/* FPEXCを設定 */
+#endif /* USE_ARM_FPU */
+	
 	/*
 	 *  非タスクコンテキスト用のスタックに切り換える．
@@ -1068,5 +1240,5 @@
 	ldr		sp, [r2]
 	push	{r0,r3}					/* 切換え前のスタックポインタを保存 */
-									/* r0はスペース確保のため */
+									/* r0はアラインメントのため */
 ALABEL(nk_exc_handler_2)
 	/*
@@ -1101,6 +1273,14 @@
 	pop		{r0,r3}
 	mov		sp, r3
+
+#ifdef USE_ARM_FPU
+	/*
+	 *  FPUを元に戻す．
+	 */
+	ldr		r0, [sp]				/* FPEXCを復帰 */
+	vmsr	fpexc, r0
+#endif /* USE_ARM_FPU */
 	b		exc_handler_5
-
+	
 /*
  *  ステータスレジスタの操作関数
@@ -1113,12 +1293,12 @@
 	ATEXT
 	AALIGN(2)
-	AWEAK(current_cpsr)
-ALABEL(current_cpsr)
+	AWEAK(_kernel_current_cpsr)
+ALABEL(_kernel_current_cpsr)
 	mrs		r0, cpsr_cxsf
 	bx		lr
 
 	AALIGN(2)
-	AWEAK(set_cpsr)
-ALABEL(set_cpsr)
+	AWEAK(_kernel_set_cpsr)
+ALABEL(_kernel_set_cpsr)
 	msr		cpsr_cxsf, r0
 	bx		lr
Index: EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/core_sym.def
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/core_sym.def	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/core_sym.def	(revision 429)
@@ -1,4 +1,7 @@
 TARGET_ARCH_ARM,__TARGET_ARCH_ARM
-USE_INTCFG_TABLE,true,bool,defined(USE_INTCFG_TABLE)
+USE_ARM_FPU,true,bool,defined(USE_ARM_FPU),false
+USE_ARM_FPU_D32,true,bool,defined(USE_ARM_FPU_D32),false
+USE_INTCFG_TABLE,true,bool,defined(USE_INTCFG_TABLE),false
+TA_FPU
 sizeof_TCB,sizeof(TCB)
 offsetof_TCB_p_tinib,"offsetof(TCB,p_tinib)"
